import * as react from 'react';

declare function useControllableProp<T>(prop: T | undefined, state: T): [boolean, T];
interface UseControllableStateProps<T> {
    value?: T;
    defaultValue?: T | (() => T);
    onChange?: (value: T) => void;
    shouldUpdate?: (prev: T, next: T) => boolean;
}
declare function useControllableState<T>(props: UseControllableStateProps<T>): [T, react.Dispatch<react.SetStateAction<T>>];

export { UseControllableStateProps, useControllableProp, useControllableState };
